apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ sympa_name }}
    backups.opsperator.io/service: backups-{{ sympa_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ sympa_name }}
  name: {{ sympa_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ sympa_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ sympa_name }}
  strategy:
    recreateParams:
      timeoutSeconds: 1200
    type: Recreate
{% else %}
    name: {{ sympa_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ sympa_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ sympa_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ sympa_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - /run-sympa.sh
        env:
        - name: ADMIN_USER
{% if do_ldap %}
          value: "{{ sympa_ldap_admin_users | join(' ') }}"
{% else %}
          value: "{{ sympa_external_admins | join(' ') }}"
{% endif %}
        - name: AUTH_METHOD
{% if do_lemon %}
          value: lemon
{% elif do_ldap %}
          value: ldap
{% else %}
          value: internal
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LEMON_FQDN
          value: "{% if do_lemon %}{{ lemon_manager | urlsplit('hostname') }}{% endif %}"
        - name: LISTS_LANG
          value: {{ sympa_lang }}
        - name: LISTS_SUBDOMAIN
          value: {{ (sympa_fqdn.split('.'))[0] }}
        - name: MAIL_DOMAIN
          value: {{ (sympa_fqdn.split('.'))[1:] | join('.') }}
        - name: MAXSIZE
          value: "{{ sympa_max_message_size }}"
{% if sympa_db_type == 'percona' %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ sppc_name }}
        - name: MYSQL_HOST
          value: {{ sppc_name }}-client
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ sppc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ sppc_name }}
{% elif sympa_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ spms_name }}
        - name: MYSQL_HOST
          value: {{ spms_name }}
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ spms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ spms_name }}
{% else %}
        - name: MYSQL_PASSWORD
          value: ""
{% endif %}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=sympa,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: sympa-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PASSWORDS_FQDN
{% if (do_ldap or do_lemon) and sympa_ldap_lockout %}
          value: {{ ssp_address | urlsplit('hostname') }}
{% else %}
          value: ""
{% endif %}
{% if sympa_db_type == 'postgres' %}
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ sppg_name }}
        - name: POSTGRES_HOST
          value: {{ sppg_name }}
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ sppg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ sppg_name }}
{% else %}
        - name: POSTGRES_PASSWORD
          value: ""
{% endif %}
        - name: PUBLIC_PROTO
          value: https
        - name: SITE_TITLE
          value: {{ sympa_site_title }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='sympa'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sympa'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                ls /run/sympa/pidsubdir/ | grep mockpid
          failureThreshold: 60
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: sympa
        resources:
          limits:
            cpu: "{{ sympa_cpu_limit }}"
            memory: "{{ sympa_memory_limit }}"
          requests:
            cpu: "{{ sympa_cpu_request }}"
            memory: "{{ sympa_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
          privileged: false
{% if k8s_flavor == 'kubernetes' %}
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: tmp
          subPath: sympaca
{% if do_ldap or do_lemon %}
        - mountPath: /certs/ca.crt
          name: pkiconf
          subPath: ca.crt
{% endif %}
{% if smtps_address | default(False) %}
        - mountPath: /certs/smtp-ca.crt
          name: pkiconf
          subPath: smtp-ca.crt
{% endif %}
{% endif %}
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /etc/mail/sympa
          name: data
          subPath: sympa-mail
        - mountPath: /etc/postfix
          name: data
          subPath: postfix-config
        - mountPath: /etc/sympa
          name: data
          subPath: sympa-config
        - mountPath: /etc/sympa.orig/cookie
          name: cookie
          subPath: cookie
        - mountPath: /usr/local/share/ca-certificates
          name: tmp
          subPath: ca-certificates-sympa
        - mountPath: /usr/share/ca-certificates
          name: tmp
          subPath: empty
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /run/sympa
          name: tmp
          subPath: sympa
        - mountPath: /var/lib/sympa
          name: data
          subPath: sympa-lib
        - mountPath: /var/spool/postfix
          name: data
          subPath: postfix-spool
        - mountPath: /var/spool/sympa
          name: data
          subPath: sympa-spool
      - args:
        - /run-postfix.sh
        env:
        - name: ADMIN_USER
{% if do_ldap %}
          value: "{{ sympa_ldap_admin_users[0] }}"
{% else %}
          value: "{{ sympa_external_admins[0] }}"
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DKIM_HOST
          value: "{{ '127.0.0.1' if (do_dkim) else '' }}"
        - name: DKIM_PORT
          value: "12345"
        - name: LISTS_LANG
          value: {{ sympa_lang }}
        - name: LISTS_SUBDOMAIN
          value: {{ (sympa_fqdn.split('.'))[0] }}
        - name: MAIL_DOMAIN
          value: {{ (sympa_fqdn.split('.'))[1:] | join('.') }}
        - name: MAXSIZE
          value: "0"
        - name: MYDOMAIN
          value: {{ root_domain }}
        - name: MYHOSTNAME
          value: smtp-sympa.{{ root_domain }}
        - name: MYNETWORKS
          value: {{ postfix_my_networks | join(' ') }} 127.0.0.1/32
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: PUBLIC_PROTO
          value: https
        - name: SMTP_PORT
{% if smtp_relay | default(False) %}
          value: "{{ smtp_port | default(25) }}"
        - name: SMTP_PROTO
          value: {{ smtp_proto | default('smtp') }}
        - name: SMTP_RELAY
          value: {{ smtp_relay }}
{% elif smtps_address | default(False) %}
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
        - name: SMTP_RELAY
          value: {{ smtps_address | urlsplit('hostname') }}
{% elif smtp_address | default(False) %}
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
        - name: SMTP_RELAY
          value: {{ smtp_address | urlsplit('hostname') }}
{% else %}
          value: ""
        - name: SMTP_PROTO
          value: ""
        - name: SMTP_RELAY
          value: ""
{% endif %}
        - name: SPAMD_HOST
{% if do_rspamd %}
          value: {{ rspamd_milter_address | urlsplit('hostname') }}
        - name: SPAMD_PORT
          value: "{{ rspamd_milter_address | urlsplit('port') }}"
{% elif do_orangeassassin %}
          value: {{ orange_address | urlsplit('hostname') }}
        - name: SPAMD_PORT
          value: "{{ orange_address | urlsplit('port') }}"
{% else %}
          value: ""
        - name: SPAMD_PORT
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='sympa'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sympa'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - /usr/local/bin/check_smtp.sh
          failureThreshold: 60
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 6
        name: postfix
        ports:
        - containerPort: 25
        - containerPort: 465
        resources:
          limits:
            cpu: {{ postfix_cpu_limit }}
            memory: {{ postfix_memory_limit }}
          requests:
            cpu: {{ postfix_cpu_request }}
            memory: {{ postfix_memory_request }}
        securityContext:
          privileged: true
          runAsUser: 0
        volumeMounts:
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/postfix
          name: data
          subPath: postfix-config
        - mountPath: /etc/sympa
          name: data
          subPath: sympa-config
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /var/spool/postfix
          name: data
          subPath: postfix-spool
      - args:
        - /run-syslog.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LISTS_LANG
          value: {{ sympa_lang }}
        - name: LISTS_SUBDOMAIN
          value: {{ (sympa_fqdn.split('.'))[0] }}
        - name: MAIL_DOMAIN
          value: {{ (sympa_fqdn.split('.'))[1:] | join('.') }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='sympa'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sympa'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -e /run/rsyslog/dev/log || exit 1
          failureThreshold: 5
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: syslog
        ports:
        - containerPort: 1514
          protocol: UDP
        resources:
          limits:
            cpu: {{ rsyslog_cpu_limit }}
            memory: {{ rsyslog_memory_limit }}
          requests:
            cpu: {{ rsyslog_cpu_request }}
            memory: {{ rsyslog_memory_request }}
        securityContext:
          privileged: true
          runAsUser: 0
        volumeMounts:
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /var/log/postfix
          name: tmp
          subPath: maillogs
      - args:
        - /run-web.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LISTS_LANG
          value: {{ sympa_lang }}
        - name: LISTS_SUBDOMAIN
          value: {{ (sympa_fqdn.split('.'))[0] }}
        - name: MAIL_DOMAIN
          value: {{ (sympa_fqdn.split('.'))[1:] | join('.') }}
{% if do_ldap and do_lemon %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=ssoapp,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: ssoapp-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='sympa'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sympa'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 60
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ sympa_fqdn }}
            path: /sympa/
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: web
        readinessProbe:
          failureThreshold: 5
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ sympa_fqdn }}
            path: /sympa/
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 4
        resources:
          limits:
            cpu: "{{ sympa_web_cpu_limit }}"
            memory: "{{ sympa_web_memory_limit }}"
          requests:
            cpu: "{{ sympa_web_cpu_request }}"
            memory: "{{ sympa_web_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
          privileged: false
{% if k8s_flavor == 'kubernetes' %}
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: tmp
          subPath: sympacaweb
        - mountPath: /certs/ca.crt
          name: pkiconf
          subPath: ca.crt
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: tmp
          subPath: apachesites
        - mountPath: /etc/apache2/ssl
          name: tmp
          subPath: apachessl
        - mountPath: /etc/apache2/tmp
          name: tmp
          subPath: apachecgitmp
        - mountPath: /usr/local/share/ca-certificates
          name: tmp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: tmp
          subPath: empty
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /etc/mail/sympa
          name: data
          subPath: sympa-mail
        - mountPath: /etc/postfix
          name: data
          subPath: postfix-config
        - mountPath: /etc/sympa
          name: data
          subPath: sympa-config
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /run/sympa
          name: tmp
          subPath: sympa
        - mountPath: /usr/lib/cgi-bin/sympa
          name: tmp
          subPath: cgibin
        - mountPath: /var/lib/sympa
          name: data
          subPath: sympa-lib
        - mountPath: /var/spool/postfix
          name: data
          subPath: postfix-spool
        - mountPath: /var/spool/sympa
          name: data
          subPath: sympa-spool
{% if do_exporters %}
      - args:
        - --postfix.logfile_path=/var/log/postfix/maillog
        - --postfix.showq_path=/var/spool/postfix/public/showq
        - --web.listen-address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='postfixexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='postfixexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 60
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter-smtp
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          privileged: true
          runAsUser: 0
        volumeMounts:
        - mountPath: /etc/postfix
          name: data
          subPath: postfix-config
        - mountPath: /var/log/postfix
          name: tmp
          subPath: maillogs
        - mountPath: /var/spool/postfix
          name: data
          subPath: postfix-spool
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9114
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 60
          httpGet:
            path: /
            port: 9114
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter-http
        ports:
        - containerPort: 9114
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
          privileged: false
{% if k8s_flavor == 'kubernetes' %}
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% endif %}
{% if do_dkim %}
      - args:
        - /run-opendkim.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DKIM_HOST
          value: 127.0.0.1
        - name: DKIM_PORT
          value: "12345"
        - name: MYNETWORKS
          value: {{ postfix_my_networks | join(' ') }} 127.0.0.1/32
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='sympa'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sympa'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -s /run/opendkim/opendkim.pid || exit 1
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: opendkim
        resources:
          limits:
            cpu: {{ opendkim_cpu_limit }}
            memory: {{ opendkim_memory_limit }}
          requests:
            cpu: {{ opendkim_cpu_request }}
            memory: {{ opendkim_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /etc/dkim.d/keys/{{ root_domain }}
          name: dkimkeys
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
{% endif %}
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
          privileged: false
{% if k8s_flavor == 'kubernetes' %}
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if do_exporters %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup | default(k8s_unprivileged_userid) }}
{% else %}
      securityContext: {}
{% endif %}
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ sympa_name }}
{% else %}
      serviceAccountName: default
{% endif %}
      terminationGracePeriodSeconds: {{ sympa_termination_timeout | default(60) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ sympa_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: cookie
        secret:
          secretName: {{ sympa_name }}
      - name: data
        persistentVolumeClaim:
          claimName: {{ sympa_name }}
{% if do_dkim %}
      - name: dkimkeys
        secret:
          defaultMode: 420
          secretName: {{ sympa_name }}-dkim
{% endif %}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
      - name: pkiconf
        projected:
          sources:
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
          - secret:
              items:
              - key: tls.crt
                path: tls.crt
              name: {{ sympa_name }}-smtp-tls
          - secret:
              items:
              - key: tls.key
                path: tls.key
              name: {{ sympa_name }}-smtp-tls
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ sympa_name }}
{% endif %}
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='sympa'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sympa
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sympa'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - postfix
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sympa'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - syslog
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sympa'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - web
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sympa'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters %}
{% if (opsimages | json_query("[?name=='postfixexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter-smtp
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='postfixexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter-http
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
{% if do_dkim and (opsimages | json_query("[?name=='sympa'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - opendkim
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sympa'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
